{ Copyright Notice
  ================
This work is copyrighted and should not be used in any commercial programs
without acceptance of the Author. However it can be freely used in any
non-commercial software, i.e. for pleasure or fun or in freeware programs.

If you find this component usefull for you and you think it has saved you
some time (I have no doubt that you could write it yourself, but how long
would it take - 10 minutes, 1 hour or several hours ?), please send a note
to the address below (I prefere E-mail, but you can send a letter).

If you will earn some money because you are using this component (whatever
way - selling program, impressing your boss), I believe it is simple fair
if you send some money to me. As I have no idea how much it is worth to you,
please send me equivalence of 10 mins payment made to you. If you are (for
example) cleaner and you get $3 per hour, then send me $0.50. If you are
High class expert and you get $120 per hour please send me 20 bucks.
I really hope that this component will be used by specialists ! :-))
}

unit TColButt;

interface


uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus;

type
  TToggleStyle = (Normal,Toggle);
  TAlignStyle = (Center, AlignLeft, AlignRight);
  TColorButton = class(TCustomControl)
  private
    FValue : boolean;
    FCaption : string;
    FColor : TColor;
    FLightColor : TColor;
    FShadowColor : TColor;
    FFont : TFont;
    FLightOn, FLightOff : boolean;
    FStyle : TToggleStyle;
    FAbout : string;
    FLines : TStringList;
    FGroupIndex : integer;
    FAlign : TAlignStyle;
    FThickness : integer; 
  protected
    Dragging : Boolean;
    procedure Paint; override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;

    procedure DrawSwitch;
    procedure SetColor(value: TColor);
    procedure SetShadowColor(value: TColor);
    procedure SetLightColor(value: TColor);
    procedure SetValue (value: Boolean);
    procedure SetCaption (value: string);
    procedure SetLines(value : TStringList);
    procedure SetStyle(value : TToggleStyle);
    procedure SetLightOn(value:boolean);
    procedure SetLightOff(value:boolean);
    procedure SetThickness(value:integer);
    procedure SetAlign(value:TAlignStyle);
    function  SetAbout:string;


  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  published
    Property Value : Boolean Read FValue Write SetValue;
    Property Caption : string Read FCaption Write SetCaption;
    Property Color : TColor Read FColor Write SetColor;
    Property LightColor : TColor Read FLightColor Write SetLightColor;
    Property ShadowColor : TColor Read FShadowColor Write SetShadowColor;
    Property LightOn : boolean Read FLightOn Write SetLightOn;
    Property LightOff: boolean Read FLightOff Write SetLightOff;
    Property Style : TToggleStyle Read FStyle Write SetStyle;
    Property Lines : TStringList Read FLines Write SetLines;
    Property About : string Read SetAbout;
    Property GroupIndex : integer Read FGroupIndex Write FGroupIndex;
    Property Thickness : integer Read FThickness Write SetThickness;
    Property ALign : TAlignStyle Read FAlign Write SetAlign;
    property Enabled;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Font;

    property TabOrder;
    property Visible;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnClick;
    property OnDblClick;

  end;

procedure Register;

implementation


procedure Register;
begin
  RegisterComponents('Standard', [TColorButton]);
end;

(******************
 TColorButton Methods
******************)

constructor TColorButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Height := 64;
  Width := 128;
  FColor := clBtnFace;
  FLightColor := clBtnHighlight;
  FShadowColor := clBtnShadow;
  FCaption:=self.name;
  FValue:=False;
  FLines:=TStringList.create;
  FLines.Add(self.name);
  FThickness:=1;
  SetAlign(Center);
end;

destructor TColorButton.Destroy;
begin
  FLines.Clear;
  Flines.Destroy;
  inherited Destroy;
end;


procedure TColorButton.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetFocus;
  if FStyle=Normal then
  begin
    FValue:=False;
    Invalidate;
  end;
end;

procedure TColorButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  XX : TControl;
  i : integer;
begin
  SetFocus;
  if FStyle=Normal then
  begin
    FValue:=True;
  end
  else
  begin
    FValue:=not FValue;
    if FValue and (GroupIndex<>0) and (parent<>nil) then
    begin
       for i:=0 to parent.ControlCount-1 do
       begin
          XX:=parent.Controls[i];
          if (XX is TColorButton) and (XX<>self) and
             ((XX as TColorButton).value) then
          begin
             (XX as TColorButton).setvalue(false);
          end;
       end;
    end;
  end;
  Invalidate;
end;


procedure TColorButton.DrawSwitch;
var
  Rect1   : TRect;
  up1,i, offx, offy, l, tw, hg, fh, w, h, xmargin, ymargin : integer;
  col1, col2 : TColor;
begin
    with Canvas do
    begin
          MoveTo(0,0);
          Pen.color:=clBlack;
          Brush.color:=FColor;
          Rectangle(0,0,width-1,height-1);
          Pen.color:=FColor;
          Brush.color:=FColor;
          Rectangle(FThickness+1,FThickness+1,width-FThickness-1,height-FThickness-1);
       if FValue then
       begin
          col1:=FShadowColor;
          col2:=FLightColor;
          if FLightOn then
          begin
             Pen.color:=clLime;
             Brush.color:=clLime;
             Rectangle(width-30,8,width-15,12);
          end;
          offx:=FThickness;
          offy:=FThickness;
       end
       else
       begin
          col1:=FLightColor;
          col2:=FShadowColor;
          if FLightOff then
          begin
             Pen.color:=clRed;
             Brush.color:=clRed;
             Rectangle(width-30,8,width-15,12);
          end;
          offx:=0;
          offy:=0;
       end;
       Pen.color:=col1;
       for i:=1 to FThickness do
       begin
         MoveTo(i,i); LineTo(i,height-i);
         MoveTo(i,i); LineTo(width-i,i);
       end;
       Pen.color:=col2;
       for i:=1 to FThickness do
       begin
         MoveTo(width-i,height-i); LineTo(i,height-i);
         MoveTo(width-i,height-i); LineTo(width-i,i);
       end;
    Brush.Color:=FColor;
    Canvas.font.color:=self.font.color;
    Canvas.font.name:=self.font.name;
    Canvas.font.size:=self.font.size;
    Canvas.font.style:=self.font.style;
    Canvas.font.pitch:=self.font.pitch;

    xmargin:=FThickness;
    ymargin:=FThickness;
    fh:=Canvas.font.height;
    if fh<0 then fh:=-fh;  { convert to the positive value, just in case }
    fh:=fh+(4);            { add external leading (just random value ! }
    hg:=fh*flines.count-4;   { calculate total height of caption }
    if hg>(height-2*ymargin-offy) then hg:=height-2*ymargin-offy;  { calc height of button }
    up1:=(height-hg) div 2;
    up1:=up1+offy-4;
    if (up1+offy<ymargin) then up1:=ymargin-offy;
    for i:=0 to flines.count-1 do
    begin
       tw:=canvas.textwidth(FLines.strings[i]);
       if tw>(width-2*xmargin-offx) then tw:=width-2*xmargin-offx
       else tw:=tw-offx;
       case FAlign of
         Center :
           l:=(width-2*xmargin-offx-tw) div 2;
         AlignRight :
           l:=width-2*xmargin-offx-tw;
         AlignLeft :
           l:=0;
       end;
       l:=l+offx;
       h:=fh;
       if (up1+h+offy+ymargin-1)>(height-ymargin) then h:=height-(2*ymargin)-up1-offy;
       if h>0 then
       begin
          Rect1:=Rect(l+xmargin+offx,up1+ymargin+offy,l+tw+xmargin-1+offx,up1+h+ymargin-1+offy);
          Canvas.TextRect(Rect1,l+xmargin+offx,up1+ymargin+offy,FLines.strings[i]);
       end;
       up1:=up1+fh;
    end;
    end;

end;


procedure TColorButton.Paint;
begin
   DrawSwitch;
end;

procedure TColorButton.SetColor(value: TColor);
begin
  if not (FColor = value) then
  begin
     FColor := value;
     Invalidate;
   end;
 end;

procedure TColorButton.SetShadowColor(value: TColor);
begin
  if not (FShadowColor = value) then
  begin
     FShadowColor := value;
     Invalidate;
   end;
 end;

procedure TColorButton.SetLightColor(value: TColor);
begin
  if (FLightColor <> value) then
  begin
     FLightColor := value;
     Invalidate;
   end;
 end;

procedure TColorButton.SetValue (value: Boolean);
begin
  if (FValue <> value) then
  begin
     FValue := value;
     Invalidate;
   end;
 end;

procedure TColorButton.SetCaption (value: string);
begin
  if (FCaption <> value) then
  begin
     FCaption := value;
     if FLines.count=0 then Flines.Add(FCaption)
     else Flines[0]:=FCaption;
     Invalidate;
   end;
 end;

procedure TColorButton.SetThickness( value : integer);
 begin
   if (FThickness <> value) then
   begin
     FThickness := value;
     Invalidate;
   end;
 end;



 procedure TColorButton.SetLightOn( value : boolean );
 begin
   if (FLightOn <> value) then
   begin
     FLightOn := value;
     Invalidate;
   end;
 end;

 procedure TColorButton.SetLightOff( value : boolean );
 begin
   if (FLightOff <> value) then
   begin
     FLightOff := value;
     Invalidate;
   end;
 end;

 procedure TColorButton.SetStyle( value : TToggleStyle );
 begin
   if (FStyle <> value) then
   begin
     FStyle := value;
     Invalidate;
   end;
 end;

 procedure TColorButton.SetLines( value : TStringList );
 var i : integer;
 begin
     FLines.clear;
     for i:=0 to value.count-1 do
         FLines.Add(value[i]);
     if Flines.count>0 then
        FCaption:=Flines[0];
     Invalidate;
 end;

 procedure TColorButton.SetAlign( value : TAlignStyle );
 var i : integer;
 begin
   if (FAlign <> value) then
   begin
     FAlign := value;
     Invalidate;
   end;
 end;

 function TColorButton.SetAbout : string ;
 begin
    ShowMessage('Please, read readme.txt about usage');
    SetAbout:='Press click to get details';
 end;


end.



